@scb-background-color: #3496a8;
@scb-top-bar-color: grey;
@scb-top-bar-height: 40px;
@scb-top-bar-margin: 10px;
@scb-top-bar-status-size: 10px;
@scb-top-bar-tags-size: 0px;
@scb-top-bar-add-contact-size: 65%;
@scb-top-bar-add-contact-spinner-size: 20px;
@scb-top-bar-close-button-size: 10px;
@scb-top-bar-i18n-size: 0px;
@scb-top-bar-padding: 0px 10px 0px 10px;
@scb-top-bar-chat-with-size: 200px;
@scb-content-color: white;
@scb-room-list-color: #f6f8fc;
@scb-room-list-padding: 10px;
@scb-room-margin: 10px;
@scb-room-padding: 20px 10px 20px 20px;
@scb-room-height: 25px;
@scb-room-icon-size: @scb-room-height;
@scb-room-unread-height: 24px;
@scb-room-unread-width: 24px;
@scb-room-unread-radius: 50%;
@scb-room-left-margin: 10px;

@scb-message-list-background: #f6f8fc;
@scb-message-list-padding: 10px;
@scb-message-photo-size: 40px;
@scb-message-photo-padding: 10px;
@scb-message-timestamp-width: 50px;
@scb-message-other-background: #ffffff;
@scb-message-me-background: #cfedfa;
@scb-message-translate: 10px;
@scb-message-space-between: 5px;
@scb-unread-indicator-size: 7px;

@scb-message-room-height: 25px;

@scb-editor-zone-height: 40px;
@scb-editor-zone-padding: 5px;

@z-height-0: none;
@z-height-1: 0 1px 3px 0 rgba(0, 0, 0, .33);
@z-height-2: 0 3px 8px 0 rgba(0, 0, 0, .38);
@z-height-3: 0 8px 14px 0 rgba(0, 0, 0, .38);
@z-height-4: 0 14px 19px 0 rgba(0, 0, 0, .38);
@z-height-5: 0 20px 24px 0 rgba(0, 0, 0, .38);

@swizi-color1: #FED129;
@swizi-color2: #19BDC1;
@swizi-color3: #FFFFFF;
@swizi-color4: #2e2e2e;
@swizi-color5: #6e6e6e;

@keyframes fadein {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

@-moz-keyframes fadein { /* sur Firefox */
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

@-webkit-keyframes fadein { /* sur Safari et Chrome */
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

@-o-keyframes fadein { /* sur Opera */
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

.box-shadow(@arguments) {
  -webkit-box-shadow: @arguments;
  -moz-box-shadow: @arguments;
  box-shadow: @arguments;
}

.set-flex-direction(@direction) {
  flex-direction: @direction;
  -webkit-flex-direction: @direction;
  -ms-flex-direction: @direction;
}

.swizi-chat-box-default-style {
  width: 100%;
  height: 100%;
  position: relative;
  box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.2);

  &:hover {
    box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2);
  }

  .swizi-chat-box {
    position: relative;
    width: 100%;
    height: 100%;
    font-family: Roboto;
    font-size: small;
    display: flex;
    .set-flex-direction(column);

    .blurred {
      filter: blur(3px)
    }

    .scb-top-bar {
      top: 0;
      left: 0;
      right: 0;
      height: @scb-top-bar-height;
      background: @swizi-color2;
      display: flex;
      padding: 0;
      .set-flex-direction(row);

      .scb-status {
        width: @scb-top-bar-status-size;
        margin-left: @scb-top-bar-margin;
        heigth: 100%;
        display: flex;
        justify-content: center;
        align-items: center;

        .scb-status-indicator {
          width: @scb-top-bar-status-size;
          height: @scb-top-bar-status-size;
          border-radius: 50%;
          cursor: pointer;
        }

        .scb-connected {
          .scb-status-indicator;
          background: darkgreen;
        }

        .scb-disconnected {
          .scb-status-indicator;
          background: darkred;
        }
      }

      .scb-user {
        width: ~"calc(100% - 3 * @{scb-top-bar-status-size} - @{scb-top-bar-close-button-size} - @{scb-top-bar-i18n-size} - @{scb-top-bar-tags-size} - @{scb-top-bar-add-contact-size} )";
        margin-left: @scb-top-bar-margin;
        height: 100%;
        font-size: 15px;
        line-height: @scb-top-bar-height;
        vertical-align: middle;
        cursor: default;
        text-decoration: none;
        color: #333;

      }

      .scb-add-contact {
        position: relative;
        width: ~"@{scb-top-bar-add-contact-size}";
        margin-left: @scb-top-bar-margin;
        height: 100%;
        line-height: @scb-top-bar-height;
        vertical-align: middle;
        cursor: default;

        button {
          position: absolute;
          width: 115px;
          height: 70%;
          right: 15px;
          top: 15%;
          margin: auto;
          border-radius: 5px;
          background-color: @scb-background-color;
          color: white;
          border: solid 1px white;

          .box-shadow(@z-height-1);

          &:focus {
            outline: none;
          }

          &:hover {
            cursor: pointer;
            background-color: darken(@swizi-color1, 10%);
          }

          &:active {
            cursor: pointer;
            background-color: darken(@swizi-color1, 10%);
            .box-shadow(@z-height-0);
          }
        }

        .scb-add-contact-panel {
          position: absolute;
          width: 25%;
          max-height: 160px;
          min-height: 60px;
          z-index: 100;

          display: block;
          font-family: Roboto;

          margin: auto;
          border-radius: 0;
          background-color: white;
          color: @swizi-color4;
          border: solid @swizi-color4 thin;
          padding: 0 0 0 0;

          .scb-add-contact-edition-zone {
            width: 100%;
            display: flex;
            align-items: center;
            justify-content: center;
            justify-items: center;

            border: solid @swizi-color4 thin;

            input {
              width: ~"calc(100% - @{scb-top-bar-add-contact-spinner-size} - 5px)";
              height: 25px;
              line-height: 25px;
              border-radius: 0;
              background-color: white;
              color: @swizi-color4;
              border: none;
              padding: 0 0 0 5px;

              &:focus {
                outline: none;
              }
            }

            .scb-add-contact-spinner {
              width: @scb-top-bar-add-contact-spinner-size;
              height: @scb-top-bar-add-contact-spinner-size;
              margin-right: 5px;

              .loading-spinner {
                width: @scb-top-bar-add-contact-spinner-size;
                height: @scb-top-bar-add-contact-spinner-size;
                border-radius: @scb-top-bar-add-contact-spinner-size;
                border: 5px solid #EDE8E6;
                border-top-color: #D4D2D0;
                box-sizing: border-box;

                animation: loading-spinner 1.2s linear infinite;
                -webkit-animation: loading-spinner 1.2s linear infinite;
              }

              @keyframes loading-spinner {
                0% {
                  transform: rotate(0deg)
                }
                100% {
                  transform: rotate(360deg)
                }
              }

              @-webkit-keyframes loading-spinner {
                0% {
                  -webkit-transform: rotate(0deg)
                }
                100% {
                  -webkit-transform: rotate(360deg)
                }
              }

            }
          }

          .scb-add-contact-user-list {
            .scb-add-contact-user-list-item {
              padding: 0 0 0 5px;
              font-size: smaller;
              height: 20px;
              line-height: 20px;
              vertical-align: center;
              margin-top: auto;

              &:hover {
                background: #EDE8E6;
                cursor: pointer;
              }
            }

            .scb-add-contact-user-list-more {
              padding: 0px 0 5px 10px;
              font-size: x-small;
              height: 20px;
              font-style: italic;
            }
          }

        }

      }

      .scb-close {
        width: @scb-top-bar-close-button-size;
        margin-right: @scb-top-bar-margin;
        height: 100%;
        display: flex;
        justify-content: center;
        align-items: center;

        .scb-close-icon {
          font: bold 1em/2em Arial, Helvetica;
          text-decoration: none;
          color: #333;

          &:before {
            content: "\2716";
            cursor: pointer;
          }

          &:hover {
            color: @swizi-color3
          }
        }
      }
    }

    .scb-content {
      width: 100%;
      height: ~"calc(100% - @{scb-top-bar-height})";
      background: @scb-content-color;
      border-top: none;
      margin-left: -2px;

      .scb-rooms {
        height: 100%;
        width: ~"calc(100% - 2 * @{scb-room-list-padding})";
        background: @scb-room-list-color;
        padding: @scb-room-list-padding;
        overflow-x: hidden;
        overflow-y: scroll;

        .scb-room {
          position: relative;
          height: @scb-room-height;
          margin-top: @scb-room-margin;
          margin-bottom: @scb-room-margin;
          padding: @scb-room-padding;
          background: #3496a8;
          display: flex;
          cursor: pointer;
          .box-shadow(@z-height-1);

          .scb-room-icon {
            width: @scb-room-icon-size;
            height: @scb-room-icon-size;
            fill: white;
          }

          .scb-room-label {
            position: relative;
            margin-left: @scb-room-margin;
            line-height: @scb-room-height;
            width: ~"calc(100% - @{scb-room-icon-size} - @{scb-room-unread-width})";
            overflow: hidden;
            color: white;
            white-space: nowrap;
            text-overflow: ellipsis;
          }

          &:hover {
            background-color: #56b4b7;
          }

          &:active {
            .box-shadow(@z-height-0);
          }
        }

        [data-unread]:after {
          content: attr(data-unread);
          position: relative;
          margin-left: @scb-room-left-margin;
          font-size: .7em;
          background: white;
          color: #3496a8;
          width: @scb-room-unread-width;
          height: @scb-room-unread-height;
          text-align: center;
          line-height: @scb-room-height;
          border-radius: 50%;
          box-shadow: 0 0 1px #333;
        }
      }

      .scb-messages {
        display: flex;
        width: 100%;
        height: 100%;
        padding: 0;
        .set-flex-direction(column);

        .scb-room-topbar {
          display: flex;
          width: 100%;
          height: @scb-message-room-height;
          background: @scb-top-bar-color;

          .scb-room-back {
            height: @scb-message-room-height;
            width: @scb-message-room-height;
            font: bold 1.5em Arial, Helvetica;
            text-decoration: none;
            margin-left: 5px;
            color: #333;
            justify-content: center;
            align-items: center;
            line-height: @scb-message-room-height;

            &:before {
              content: "\021E6";
              cursor: pointer;
            }
          }

          .scb-room-back-disable {
            .scb-room-back;

            &:before {
              content: "";
            }
          }

          .scb-room-name {
            height: 100%;
            line-height: 100%;
            margin-top: 5px;
          }
        }

        .scb-message-list {
          width: ~"calc(100% - 2 * @{scb-message-list-padding})";
          height: ~"calc(100% - @{scb-editor-zone-height})";
          background: white;
          overflow: hidden;
          background: @scb-message-list-background;
          padding: @scb-message-list-padding;
          overflow: scroll;

          .scb-message-me {
            width: 100%;
            margin-top: @scb-message-space-between;
            display: -webkit-flex;
            display: flex;
            -webkit-justify-content: flex-end;
            justify-content: flex-end;

            .scb-user-message {
              display: flex;
              display: -webkit-flex;
              -webkit-justify-content: flex-end;
              justify-content: flex-end;
              width: ~"calc(100%  -  @{scb-message-photo-size} - @{scb-message-photo-padding} - @{scb-message-timestamp-width} - @{scb-message-translate})";
              margin-left: ~"calc(@{scb-message-photo-size} + @{scb-message-photo-padding} + @{scb-message-translate})";

              .scb-message {
                text-align: right;

                background: @scb-message-me-background;
                margin-right: 5px;
                padding: 5px;
                border-radius: 5px;
              }
            }

            .scb-timestamp {
              width: @scb-message-timestamp-width;
              font-size: 65%;
              color: @scb-top-bar-color;
              text-align: right;
            }

          }

          .scb-message-other {
            display: flex;
            width: 100%;
            margin-top: 10px;

            .scb-photo {
              width: @scb-message-photo-size;
              height: @scb-message-photo-size;
              margin-right: @scb-message-photo-padding;
              border-radius: 50%;

              overflow: hidden;

              img {
                width: @scb-message-photo-size;
                height: auto;
              }
            }

            .scb-user-message {
              width: ~"calc(100%  -  @{scb-message-photo-size} - @{scb-message-photo-padding} - @{scb-message-timestamp-width} - @{scb-message-translate})";
              margin-right: @scb-message-translate;

              .scb-username {
                overflow: hidden;
                width: 100%;
                color: @scb-top-bar-color;
                text-transform: uppercase;
                font-size: 70%;
                margin-bottom: 5px;
                white-space: nowrap;
                text-overflow: ellipsis;
              }

              .scb-message {
                display: flex;
                .set-flex-direction(row);

                background: @scb-message-other-background;
                padding: 3px;
                border-radius: 15px;

                justify-content: left;
                align-items: center;

                .scb-message-indicator {
                  width: 2px;
                  height: 60px;
                  cursor: default;
                  margin-right: 5px;
                }

                .scb-read {
                  .scb-message-indicator;
                  background: @scb-message-other-background;
                }

                .scb-unread {
                  .scb-message-indicator;
                  background: darkred;
                }

                .scb-message-text {

                }

                .scb-message-text-unread {
                  .scb-message-text;
                  font-weight: bold;
                }

                .scb-message-text-read {
                  .scb-message-text;
                }

              }

              .spinner {
                width: 40px;
                text-align: center;
              }

              .spinner > div {
                width: 6px;
                height: 6px;
                background-color: @swizi-color2;

                border-radius: 100%;
                display: inline-block;
                -webkit-animation: sk-bouncedelay 1.4s infinite ease-in-out both;
                animation: sk-bouncedelay 1.4s infinite ease-in-out both;
              }

              .spinner .bounce1 {
                -webkit-animation-delay: -0.32s;
                animation-delay: -0.32s;
              }

              .spinner .bounce2 {
                -webkit-animation-delay: -0.16s;
                animation-delay: -0.16s;
              }

              @-webkit-keyframes sk-bouncedelay {
                0%, 80%, 100% {
                  -webkit-transform: scale(0)
                }
                40% {
                  -webkit-transform: scale(1.0)
                }
              }

              @keyframes sk-bouncedelay {
                0%, 80%, 100% {
                  -webkit-transform: scale(0);
                  transform: scale(0);
                }
                40% {
                  -webkit-transform: scale(1.0);
                  transform: scale(1.0);
                }
              }
            }

            .scb-timestamp {
              width: @scb-message-timestamp-width;
              margin: auto;
              font-size: 65%;
              color: @scb-top-bar-color;
              text-align: right;
            }
          }
        }

        .scb-editor-zone {
          width: 100%;
          height: @scb-editor-zone-height;
          line-height: @scb-editor-zone-height;
          justify-content: center;
          align-items: center;
          display: flex;
          background: white;
          overflow: hidden;

          input[type=text] {
            width: ~"calc(100% - @{scb-editor-zone-height})";
            height: @scb-editor-zone-height;
            border: none;
            padding: 0;
            font-size: 1.2em;

            &:focus {
              outline: none;
            }

            &::-webkit-input-placeholder {
              color: #D5D5D5;
            }

            &::-moz-placeholder { /* Mozilla Firefox 19+ */
              color: #D5D5D5;
              opacity: 1;
            }

            &:-ms-input-placeholder { /* Internet Explorer 10-11 */
              color: #D5D5D5;
            }
          }

          .scb-send-message {
            height: ~"calc(@{scb-editor-zone-height} * 0.75)";
            width: ~"calc(@{scb-editor-zone-height} * 0.75)";
            margin-right: @scb-editor-zone-padding;
            background: white;
            fill: @scb-background-color;
            cursor: pointer;

            &:active {
              fill: darken(@scb-background-color, 20%);
            }

            &:disabled {
              fill: lighten(@scb-background-color, 80%);
            }

          }
        }
      }
    }

    .blur {
      -webkit-filter: blur(3px);
      -moz-filter: blur(3px);
      -o-filter: blur(3px);
      -ms-filter: blur(3px);
      filter: blur(3px);
    }

    .starting-spinner {
      width: 100%;
      height: 100%;
      display: flex;
      flex-direction: column;
      -webkit-flex-direction: column;

      .spinner {
        margin: auto;
        width: 120px;
        height: 120px;
        border-radius: 120px;
        border: 15px solid #EDE8E6;
        border-top-color: #D4D2D0;
        box-sizing: border-box;

        animation: spinner 1.2s linear infinite;
        -webkit-animation: spinner 1.2s linear infinite;
      }


      @keyframes spinner {
        0% {
          transform: rotate(0deg)
        }
        100% {
          transform: rotate(360deg)
        }
      }

      @-webkit-keyframes loading-spinner {
        0% {
          -webkit-transform: rotate(0deg)
        }
        100% {
          -webkit-transform: rotate(360deg)
        }
      }

    }

  }

  .scb-new-zone {
    position: absolute;
    top: 5%;
    bottom: 35%;
    left: 5%;
    right: 5%;
    background-color: white;
    z-index: 5;
    padding: 10px 10px 10px 10px;
    box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2);
    transition: 0.3s;

    &:hover {
      box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.2);
    }

    .scb-nz-filter {
      position: relative;
      display: flex;
      flex-direction: column;
      font-family: Roboto;

      p {
        width: 100%;
        font-family: Roboto;
        text-align: center;
      }

      input {
        line-height: 30px;
        font-size: 0.8em;
        padding: 0px 5px 0px 5px;
        outline: none;
      }

      button {
        position: absolute;
        right: 10px;
        bottom: 10px;
        width: 20px;
        height: 20px;
        cursor: pointer;
        border: none;
        padding: 0;
        outline: none;

        transition: 3s;
        animation: fadein 1s;
        -moz-animation: fadein 1s; /* Firefox */
        -webkit-animation: fadein 1s; /* Safari et Chrome */
        -o-animation: fadein 1s; /* Opera */

        &:active {
          border:none;
        }
      }

      ul {
        position: absolute;
        display: flex;
        flex-direction: column;
        top: 100px;
        left: 0;
        right: 0;
        background-color: white;
        max-height: 400px;
        overflow-y: auto;
        overflow-x: hidden;
        display: flex;
        padding: 10px 25px 25px 15px;
        margin-block-end: 0;
        margin-block-start: 0;
        .box-shadow(@z-height-1);

        li {
          font-size: 13px;
          padding-left: 5px;
          margin: 0 5px;
          border-radius: 2px;
          transition: all 150ms linear;
          display: block;
          clear: both;
          font-weight: 400;
          line-height: 2;
          white-space: nowrap;
          color: #333;
          padding-right: 30px;
          cursor: pointer;

          &:hover {
            background-color: @swizi-color1;
            color: #FFFFFF;
            box-shadow: 0 12px 20px -10px rgba(156, 39, 176, 0.28), 0 4px 20px 0px rgba(0, 0, 0, 0.12), 0 7px 8px -5px rgba(156, 39, 176, 0.2)
          }

          &:active {
            background-color: @swizi-color1;
            color: #FFFFFF;
            box-shadow: 0 6px 10px -10px rgba(156, 39, 176, 0.28), 0 4px 20px 0px rgba(0, 0, 0, 0.12), 0 7px 8px -5px rgba(156, 39, 176, 0.2)
          }
        }
      }
    }

    .scb-nz-contacts {
      padding-left: 10px;
      li {
        font-family: Roboto;
        font-size: small;
        cursor: default;
        color:@swizi-color5;
        list-style-type: none;
        margin-block-end: 0;
        margin-block-start: 10px;
        padding-inline-start: 10px;
      }
    }

    .scb-nz-actions {
      position: absolute;
      display: flex;
      justify-content: space-around;
      height: 45px;
      bottom: 10px;
      left: 0;
      right: 0;

      button {
        width: 80px;
        height: 40px;
        border-radius: 22px;
        cursor: pointer;
        outline: none;
        box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2);
        border: none;

        &:active {
          box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.2);

        }
      }

      .cancel {
        background: white;
        border: solid 1px @swizi-color2;
        color: @swizi-color2;
      }

      .valid {
        background: @swizi-color2;
        color: white;
      }
    }

  }
}
